using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_Aplicacion.Modelos_MantenimientoSimple;
using Exferia_EntityFramework;
using Exferia_General._0_Modelos;
using System;
using System.Collections.Generic;
using System.Data.Objects.SqlClient;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_General._1_Datos
{
    public class GEN_PerfilesFuncionalidad_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo> g_lst_INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo = null;
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_GEN = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(GEN_PerfilesFuncionalidad).Name), _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo != null) && (g_lst_INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo.Count() > 0))
                {
                    lst_GEN = g_lst_INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_PerfilesFuncionalidad_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_GEN;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_GEN = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(GEN_PerfilesFuncionalidad).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo != null) && (g_lst_INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo.Count() > 0))
                {
                    dnm_GEN = g_lst_INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_PerfilesFuncionalidad_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_GEN;
        }

        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_SQL =
                    " SELECT " +
                        nameof(INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo.id) + " = " + nameof(GEN_PerfilesFuncionalidad.id) + "," +
                        nameof(INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo.codigo) + " = " + nameof(GEN_PerfilesFuncionalidad.codigo) + "," +
                        nameof(INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo.descripcion) + " = " + nameof(GEN_PerfilesFuncionalidad.descripcion) + 
                " FROM " + nameof(GEN_PerfilesFuncionalidad) +
                " WHERE " + nameof(GEN_PerfilesFuncionalidad.fechaBorrado) + " IS null AND " +
                        (_lng_id > -1 ? (nameof(GEN_PerfilesFuncionalidad.id) + "=@id") : " 1 = 1 ");

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_PerfilesFuncionalidad_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener

        private dynamic g_dnm_Modelo_Obtener = null;
        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                  " SELECT distinct " +
                       nameof(GEN_PerfilesFuncionalidad.id) + "," +
                       nameof(GEN_PerfilesFuncionalidad.codigo) + "," +
                       nameof(GEN_PerfilesFuncionalidad.descripcion) + "," +
                       nameof(GEN_PerfilesFuncionalidad.fechaBorrado) +
                  " FROM " + nameof(GEN_PerfilesFuncionalidad) +
                  " WHERE " + nameof(GEN_PerfilesFuncionalidad.fechaBorrado) + " IS null AND " +
                           nameof(GEN_PerfilesFuncionalidad.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<GEN_PerfilesFuncionalidad>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_PerfilesFuncionalidad_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        public List<INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo> Obtener_Listado()
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo> lst_GEN = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                string str_SQL = " SELECT " + 
                                    nameof(INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo.id) + " = " + nameof(GEN_PerfilesFuncionalidad.id) + "," + 
                                    nameof(INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo.codigo) + " = " + nameof(GEN_PerfilesFuncionalidad.codigo) + "," +
                                    nameof(INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo.descripcion) + " = " + nameof(GEN_PerfilesFuncionalidad.descripcion) + "," +
                                    nameof(INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo.fechaBorrado) + " = " + nameof(GEN_PerfilesFuncionalidad.fechaBorrado) +
                                " FROM " + nameof(GEN_PerfilesFuncionalidad) + 
                                " WHERE " + nameof(GEN_PerfilesFuncionalidad.fechaBorrado) + " is null ";
                // ..............................................................

                //Rellenar el Modelo
                lst_GEN = obj_Exferia_Entities.Database.SqlQuery<INTERNO_GEN_PerfilesFuncionalidad_Listado_Modelo>(str_SQL, new object[] { }).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_PerfilesFuncionalidad_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_GEN;
        }

        public long Obtener_Ultimo_Id()
        {
            Exferia_Entities obj_Exferia_Entities = null;
            long lng_Id = 0;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                string str_SQL = " SELECT max(" + nameof(GEN_PerfilesFuncionalidad.id) + " ) "+ 
                                " FROM " + nameof(GEN_PerfilesFuncionalidad);
                // ..............................................................

                //Rellenar el Modelo
                long? lng_UltimoId = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL).FirstOrDefault();
                if (lng_UltimoId!=null)
                {
                    lng_Id= lng_UltimoId.Value;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_PerfilesFuncionalidad_Datos) + "/" + nameof(Obtener_Ultimo_Id), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lng_Id;
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private GEN_PerfilesFuncionalidad g_mdl_GEN_PerfilesFuncionalidad = null;
        public GEN_PerfilesFuncionalidad Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(GEN_PerfilesFuncionalidad) + "." + nameof(GEN_PerfilesFuncionalidad.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id", _lng_id)
                };

                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_PerfilesFuncionalidad_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_GEN_PerfilesFuncionalidad;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;
                

                //Rellenar el Modelo
                g_mdl_GEN_PerfilesFuncionalidad = obj_Exferia_Entities.Database.SqlQuery<GEN_PerfilesFuncionalidad>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_PerfilesFuncionalidad_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }


        #endregion

        #region Modelo Listado
        public List<GEN_PerfilesFuncionalidad> Obtener_ModeloListado_Por_Ids(List<long> _lst_ids)
        {
            try
            {
                if (_lst_ids != null && _lst_ids.Count > 0)
                {
                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(GEN_PerfilesFuncionalidad),
                                                                                             nameof(GEN_PerfilesFuncionalidad.id),
                                                                                             G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                             _lst_ids);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                    " WHERE " +
                                        str_Filtros_IDS;


                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { });


                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_PerfilesFuncionalidad_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_GEN_PerfilesFuncionalidad;
        }
        #region Ejecutar Consulta
        private List<GEN_PerfilesFuncionalidad> g_lst_GEN_PerfilesFuncionalidad = null;

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;
                
                //Rellenar el listado
                g_lst_GEN_PerfilesFuncionalidad = obj_Exferia_Entities.Database.SqlQuery<GEN_PerfilesFuncionalidad>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_PerfilesFuncionalidad_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(GEN_PerfilesFuncionalidad.id) + " , " +
                    nameof(GEN_PerfilesFuncionalidad.codigo) + " , " +
                    nameof(GEN_PerfilesFuncionalidad.descripcion) + " , " +
                    nameof(GEN_PerfilesFuncionalidad.fechaBorrado) +
                " FROM " + nameof(GEN_PerfilesFuncionalidad);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                GEN_PerfilesFuncionalidad mdl_GEN_PerfilesFuncionalidad_AGrabar = (GEN_PerfilesFuncionalidad)_mdl_obj;
                GEN_PerfilesFuncionalidad mdl_GEN_PerfilesFuncionalidad_DatosViejos = new GEN_PerfilesFuncionalidad();

                // Ver si existe ###################################################################### 
                GEN_PerfilesFuncionalidad mdl_GEN_PerfilesFuncionalidad_Final = Obtener_Modelo_Por_Id(mdl_GEN_PerfilesFuncionalidad_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_GEN_PerfilesFuncionalidad_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_GEN_PerfilesFuncionalidad_Final, mdl_GEN_PerfilesFuncionalidad_DatosViejos, false, false);

                    //Cargar los Datos Nuevos para la Trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_GEN_PerfilesFuncionalidad_AGrabar, mdl_GEN_PerfilesFuncionalidad_Final, false, false);

                    #region update
                    string str_SQL_Update = " UPDATE " + nameof(GEN_PerfilesFuncionalidad) +
                                           " SET " +
                                                  nameof(GEN_PerfilesFuncionalidad.codigo) + "=@codigo," +
                                                  nameof(GEN_PerfilesFuncionalidad.descripcion) + "=@descripcion," +
                                                  nameof(GEN_PerfilesFuncionalidad.fechaBorrado) + "=@fechaBorrado" +
                                           " WHERE " +
                                               nameof(GEN_PerfilesFuncionalidad.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_GEN_PerfilesFuncionalidad_AGrabar.codigo),
                        new SqlParameter("@descripcion",  mdl_GEN_PerfilesFuncionalidad_AGrabar.descripcion),
                         mdl_GEN_PerfilesFuncionalidad_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_GEN_PerfilesFuncionalidad_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_GEN_PerfilesFuncionalidad_AGrabar.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = mdl_GEN_PerfilesFuncionalidad_AGrabar.id;
                }
                //INSERT
                else
                {
                    mdl_GEN_PerfilesFuncionalidad_Final = new GEN_PerfilesFuncionalidad();

                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos Del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_GEN_PerfilesFuncionalidad_AGrabar, mdl_GEN_PerfilesFuncionalidad_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(GEN_PerfilesFuncionalidad) +
                                               " (" +
                                                       nameof(GEN_PerfilesFuncionalidad.id) + "," +
                                                       nameof(GEN_PerfilesFuncionalidad.codigo) + "," +
                                                       nameof(GEN_PerfilesFuncionalidad.descripcion) + "," +
                                                       nameof(GEN_PerfilesFuncionalidad.fechaBorrado) +
                                               " ) " +
                                               " VALUES " +
                                               " ( " +
                                                   "@id," +
                                                   "@codigo," +
                                                   "@descripcion," +
                                                   "@fechaBorrado" +
                                               " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@id",  mdl_GEN_PerfilesFuncionalidad_AGrabar.id),
                        new SqlParameter("@codigo",  mdl_GEN_PerfilesFuncionalidad_AGrabar.codigo),
                        new SqlParameter("@descripcion",  mdl_GEN_PerfilesFuncionalidad_AGrabar.descripcion),
                        mdl_GEN_PerfilesFuncionalidad_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_GEN_PerfilesFuncionalidad_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)

                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Insert, arr_Parametros_Insert);

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = mdl_GEN_PerfilesFuncionalidad_AGrabar.id;
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(GEN_PerfilesFuncionalidad), mdl_GEN_PerfilesFuncionalidad_DatosViejos, mdl_GEN_PerfilesFuncionalidad_Final, mdl_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_PerfilesFuncionalidad) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                GEN_PerfilesFuncionalidad mdl_GEN_PerfilesFuncionalidad_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_GEN_PerfilesFuncionalidad_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(GEN_PerfilesFuncionalidad) +
                                              " SET " +
                                              nameof(GEN_PerfilesFuncionalidad.fechaBorrado) + "=@fechaBorrado " +
                                          " WHERE " +
                                              nameof(GEN_PerfilesFuncionalidad.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(GEN_PerfilesFuncionalidad), null, mdl_GEN_PerfilesFuncionalidad_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                //Devolver tambien el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_PerfilesFuncionalidad) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            return null;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}